import { JsonRpcProvider } from '@pokt-foundation/pocketjs-provider';
import { AbstractSigner, KeyManager } from '@pokt-foundation/pocketjs-signer';
import { HTTPMethod, Node, PocketAAT, RelayHeaders, Session } from '@pokt-foundation/pocketjs-types';
import { AbstractRelayer } from './abstract-relayer';
export declare class Relayer implements AbstractRelayer {
    readonly keyManager: KeyManager | AbstractSigner;
    readonly provider: JsonRpcProvider;
    readonly dispatchers: string[];
    constructor({ keyManager, provider, dispatchers }: {
        keyManager: any;
        provider: any;
        dispatchers: any;
    });
    getNewSession({ applicationPubKey, chain, sessionBlockHeight, options, }: {
        applicationPubKey?: string;
        chain: string;
        sessionBlockHeight?: number;
        options?: {
            retryAttempts?: number;
            rejectSelfSignedCertificates?: boolean;
            timeout?: number;
        };
    }): Promise<Session>;
    static relay({ blockchain, data, headers, keyManager, method, node, path, pocketAAT, provider, session, }: {
        data: string;
        blockchain: string;
        pocketAAT: PocketAAT;
        provider: JsonRpcProvider;
        keyManager: KeyManager | AbstractSigner;
        headers?: RelayHeaders | null;
        method: HTTPMethod | '';
        session: Session;
        node: Node;
        path: string;
    }): Promise<any>;
    relay({ blockchain, data, headers, method, node, path, pocketAAT, session, }: {
        data: string;
        blockchain: string;
        pocketAAT: PocketAAT;
        headers?: RelayHeaders | null;
        method: HTTPMethod | '';
        session: Session;
        node: Node;
        path: string;
    }): Promise<any>;
    static getRandomSessionNode(session: Session): Node;
    static isNodeInSession(session: Session, node: Node): boolean;
    static generateProofBytes({ entropy, sessionBlockHeight, servicerPublicKey, blockchain, pocketAAT, requestHash, }: {
        entropy: bigint | string | number;
        sessionBlockHeight: string | number;
        servicerPublicKey: string;
        blockchain: string;
        pocketAAT: PocketAAT;
        requestHash: any;
    }): string;
    static hashAAT(aat: PocketAAT): string;
    static hashRequest(requestHash: any): string;
}
//# sourceMappingURL=relayer.d.ts.map